%kmdl video4linux

%define snapshot 20110208_132512
%define pkg_snapshot 20110208-132512
Summary: V4L2 drivers
Name: video4linux
Version: %{snapshot}
Epoch: 1
Release: 98%{?dist}
URL: http://linuxtv.org/v4lwiki/
Source0: video4linux-%{pkg_snapshot}.tar.bz2
Source1: http://linuxtv.org/downloads/drivers/linux-media-2011-02-16.tar.bz2
Source2: http://linuxtv.org/downloads/drivers/linux-media-2011-02-16.tar.bz2.md5
Patch0: video4linux-20101129-104352-cx88.patch
Patch1: v4l-dvb-abd3aac6644e-rhel5.patch
Patch2: http://launchpadlibrarian.net/58117374/cx88-dvb.c.patch
#Patch3: video4linux-20110208-132512-autosuspend_delay.patch
License: GPLv2
Group: Applications/Multimedia
BuildRoot: %{_tmppath}/%{name}-root
%kmdl_parentdependencies
Obsoletes: bttv, saa7134, cx88

%description
This package contains various v4l2 drivers.

%package -n %kmdl_name
%kmdl_dependencies
Summary: kernel modules for V4L2 drivers
Version: %{snapshot}
Epoch: 1
Group: System Environment/Kernel
Obsoletes: %{kmdl_nameof bttv}
Obsoletes: %{kmdl_nameof saa7134}
Obsoletes: %{kmdl_nameof cx88}
Obsoletes: %{kmdl_nameof ivtv}
Obsoletes: %{kmdl_nameof video4linux-ivtv}

%description -n %kmdl_name
%kmdl_desc

%package devel
Summary: %{name} kernel header files
Group: Development/System
#Requires: %{name} = %{eversion}
Provides: video4linux-kernheaders = %{evr}
Obsoletes: video4linux-kernheaders < %{evr}

%description devel
The %{name} kernel headers are used for accessing the kernel modules' API.

%prep
%setup -q -n %{name}-%{pkg_snapshot}
cp -a %{SOURCE1} linux/linux-media.tar.bz2
make -C linux untar
%patch0 -p1 -b .cx88
#patch3 -p1 -b .autosuspend_delay
if grep 'RHEL_MAJOR 5' %{kmdl_kernelsrcdir}/include/linux/version.h \
   > /dev/null; then
%patch1 -p1 -b .rhel5
fi
pushd linux/drivers/media/video/cx88/
%patch2 -p0 -b .hvr1300
popd
grep -rl /sbin/depmod . \
  | xargs -r perl -pi -e's,/sbin/depmod,:,'
grep -rl ../../../sound/oss/aci.h . \
  | xargs -r perl -pi -e's,../../../sound/oss/aci.h,%{kmdl_kernelsrcdir}/sound/oss/aci.h,'
perl -pi -e's,uname -r,echo %{_kernel},' v4l/Makefile
perl -pi -e's,strip,:,' v4l/Makefile
grep _xmit_lock %{kmdl_kernelsrcdir}/include/linux/netdevice.h > /dev/null \
  && perl -pi -e's,xmit_lock,_xmit_lock,' linux/drivers/media/dvb/dvb-core/dvb_net.c
grep -rl ./scripts/rmmod.pl . \
  | xargs -r perl -pi -e's,./scripts/rmmod.pl,:,'
grep -rl '#include <linux/config.h>' . | xargs perl -pi -e's,#include <linux/config.h>,/* #include <linux/config.h> */,'

%build
%if %{kmdl_userland}
%else
%kmdl_config

make -C v4l OUTDIR=%{kmdl_kernelsrcdir} all
# V=1 CC='gcc -H'

%endif

%install
rm -rf %{buildroot}

%if %{kmdl_userland}

mkdir -p %{buildroot}%{_includedir}
cp -a linux/include %{buildroot}%{_includedir}/v4l
cat > %{buildroot}%{_includedir}/v4l/linux/compiler.h << EOF
#ifndef __LINUX_COMPILER_H
# define __LINUX_COMPILER_H     1
# define __user
# define __undef__LINUX_COMPILER_H
#endif
EOF

%else

make -C v4l install \
  KDIR26=%{buildroot}%{kmdl_moduledir}/drivers/media \
  OUTDIR=%{kmdl_kernelsrcdir}

%endif

%clean
rm -rf %{buildroot}

%post -n %kmdl_name
%kmdl_install

%postun -n %kmdl_name
%kmdl_remove

%if %{kmdl_userland}

%files
%defattr(-,root,root,-)

%files devel
%defattr(-,root,root,-)
%{_includedir}/v4l

%else

%kmdl video4linux
%files -n %kmdl_name
%defattr(-,root,root,-)
%{kmdl_moduledir}

%endif

%changelog
* Tue Feb 22 2011 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20110208_132512-98
- Update to latest snapshot.

* Sat Nov 27 2010 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20100702-95
- Updated to latest snapshot.

* Thu Apr 01 2010 Paulo Roma <roma@lcg.ufrj.br> - 1:201090401-92
- Updated to current snapshot.
- Removed patch0.

* Thu Sep 17 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20090907-91
- Allow building of cx88 on kernels older than 2.6.22.
- Merge ivtv subpackage back into main package.

* Fri Sep 11 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20090907-90
- fix compilation with kernels older than 2.6.30

* Mon Sep  7 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20090907-89
- Update to latest git.

* Wed Apr 15 2009 Paulo Roma <roma@lcg.ufrj.br> - 1:20090415-88.0.4
- Update to 20090415

* Tue Jan 16 2009 Paulo Roma <roma@lcg.ufrj.br> - 1:20090116-88.0.3
- Update to 20090116
- Removed cxx88 patch.

* Tue Jan 15 2009 Paulo Roma <roma@lcg.ufrj.br> - 1:20090106-88.0.2
- Patched for cxx88.

* Tue Jan 06 2009 Paulo Roma <roma@lcg.ufrj.br> - 1:20090106-88.0.1
- Update to 20090106
- Removed obsolete patch video4linux-20071226-cs5345.patch

* Thu Dec 18 2008 Paulo Roma <roma@lcg.ufrj.br> - 1:20081218-87
- Update to 20081218.
  hg clone http://linuxtv.org/hg/v4l-dvb
- Removed patch 1: there is no more file 
  linux/drivers/media/video/videodev.c

* Sun Jun 22 2008 Paulo Roma <roma@lcg.ufrj.br> - 1:20080622-86
- Update to 20080622.

* Tue Mar 11 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20080311-85
- Update to 20080311.

* Wed Dec 26 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20071226-84
- Update to 20071226.

* Sat Dec  8 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20071208-83
- Update to 20071208.

* Thu Nov 29 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20071129-83
- Update to 20071129.

* Tue Nov 20 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20071120-82
- Update to 20071020.

* Tue Jul 31 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20070731-81
- Update to 20070731.

* Fri Apr 20 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20070420-79
- Update to 20070420.

* Fri Mar  2 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20070302-78
- Update to 20070302.

* Tue Nov  7 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20061107-77
- Update to 20061107.

* Sun Jul 23 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20060723-76
- Update to 20060723.

* Mon Jul 17 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:20060717-75
- Update to 20060717.

* Mon Jun 26 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 20060627.

* Sun May 28 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 20060528.
- Fix boolean vs bool issue, resurrect v4l1.

* Thu May 25 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 20060525.

* Mon Apr 10 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 20060410.

* Sun Apr  9 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 20060409.

* Sat Apr  8 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to latest tip of hg.

* Thu Mar 30 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to latest tip of hg.

* Sun Mar 26 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update against mercurial (hg) repo.

* Thu Nov 10 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to cvs 20051110.

* Wed Nov  9 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to cvs 20051109-103024.

* Mon Oct 31 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to cvs 20051031-131502.

* Sun Jul 10 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to snapshot 20050708-202133.

* Wed Mar 16 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to snapshot 20050310-100754.
- More patches by Jarod Wilson.

* Mon Feb 28 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to snapshot 20050224-133230.
- Add Jarod Wilson patches for the PVR 500MCE.

* Fri Jan 14 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to snapshot 20050113-172233.

* Sun Sep 12 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to snapshot 20040910-121305.

* Fri Jun 18 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to snapshot 20040609-095118.

* Thu May 13 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Updated to snapshot 20040515.

* Wed Feb 18 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Updated to snapshot 20040218.

* Thu Feb 12 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Still fixing the last remnants of the kmdl provides bug
  (reported by Preet Khalsa <preet@ecbit.com>).

* Thu Feb  5 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Fix kmdl provides (reported by Stefan Smietanowski <stesmi@stesmi.com>).

* Wed Jan 21 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Use video4linux as base source.
- Effectivly merged bttv, saa7134 and cx88 into one srpm.
- merged changelogs.
- Fixed order of snapshot/version, epoch bump required :(

* Sun Dec 21 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [cx88] Update to 0.0.1.

* Sun Dec 21 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [saa7134] Update to 0.2.9.
- [saa7134] Remove i2c >= 2.8.0 patch, it is handled upstream now.

* Sat Dec 20 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Update to 0.9.12.
- [bttv] Remove i2c >= 2.8.0 patch, it is handled upstream now.

* Tue Sep 30 2003 Axel Thimm <Axel.Thimm@ATrpms.net> 
- [cx88] Initial build.

* Sun Aug 10 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [saa7134] Update to 0.2.8.

* Sun Aug 10 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Update to 0.9.11.

* Tue Jun 17 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [saa7134] Initial build.
- [saa7134] Used bttv spec as a template.

* Wed Jun 11 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Updated to 0.9.10.
- [bttv] Add Ali's patch for ALi M1647/M1651.

* Wed Mar 19 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Updated to 0.9.7.

* Tue Mar 11 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Used new kernel module build packaging environment.

* Wed Mar  5 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Updated to 0.9.6.

* Sat Nov 16 2002 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Initial build.
